/* This file is part of Ebola: El octavo pasajero. */

/*     Ebola: El octavo pasajero is free software: you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License as published by */
/*     the Free Software Foundation, either version 3 of the License, or */
/*     (at your option) any later version. */

/*     Ebola: El octavo pasajero is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with Ebola: El octavo pasajero.  If not, see <http://www.gnu.org/licenses/>. */

/*
  @file model.h
  @brief The model file for configure the sprites and tiles positions.
  @author Jesus Manresa Parres, Francisco Manuel Garcia Botella, Primo Escandell Luis, Almira Molla Alejandro
  @version 1
*/

#ifndef __MODEL_H__
#define __MODEL_H__
#include <sprites.h>
#include "my_models.h"
#include "my_sprites.h"


unsigned char level = 1;

unsigned char huellas;
/**
  @short The background map.
*/  
enum BackgroundMap backgroundTiles_[ARCADEMAP_WIDTH][ARCADEMAP_HEIGHT];

/**
  @short The background map.
*/  
enum BackgroundMap backgroundTilesSecondary_[ARCADEMAP_WIDTH][ARCADEMAP_HEIGHT];

/**
  @short The position on map.
*/
struct TPosition positionOnMap;

/**
  @short The position of character.
*/
struct TPosition positionOfCharacter;

/**
  @short The position of one enemy.
*/
struct TEnemy enemies[ENEMIES];

/**
  @short The vector of characterShoots.
*/
struct TShot characterShoots[6];

/**
  @short The vector of footprints.
*/
struct TSimplePosition footPrints[MAP_FOOTPRINT];

/**
 * @short The vector of waypoints.
 */
struct TSimplePosition wayPoints[MAX_WAYPOINTS];

unsigned char shootsCartridge; //0000 0000

const unsigned char MaxShoots = 0x20; // --> MAX: 0010 0000 (6 shots Ej: pistol. [Scope 3 shots , SMG 8 shots])


void setWayPoints(){

   wayPoints[0].x = 5;
   wayPoints[0].y = 5;

   wayPoints[1].x = 10;
   wayPoints[1].y = 10;

   wayPoints[2].x = 15;
   wayPoints[2].y = 15;

   wayPoints[3].x = 20;
   wayPoints[3].y = 20;

   wayPoints[4].x = 5;
   wayPoints[4].y = 10;

   wayPoints[5].x = 10;
   wayPoints[5].y = 5;

   wayPoints[6].x = 20;
   wayPoints[6].y = 10;

   wayPoints[7].x = 10;
   wayPoints[7].y = 50;

   wayPoints[8].x = 15;
   wayPoints[8].y = 10;

   wayPoints[9].x = 10;
   wayPoints[9].y = 15;

//   wayPoints[0].x = 5;
// wayPoints[0].y = 10;
}

unsigned char abs(unsigned char number) {
if (number < 0) return -number;
else return number;
}

unsigned char nearWayPointorCharacter(unsigned char enemy){

unsigned char _i;
unsigned char nearest;
unsigned char nearest_aux_x, nearest_aux_y, nearest_x, nearest_y;

nearest = 0;

nearest_x =  positionOfCharacter.x;// wayPoints[0].x;
nearest_y =  positionOfCharacter.y;//wayPoints[0].y;

nearest_aux_x = MAX_WAYPOINTS + 1;
nearest_aux_y = MAX_WAYPOINTS + 1;

for (_i=0; _i < MAX_WAYPOINTS; ++_i) {

    if(abs(_i-nearest_x) < enemies[enemy].position.x){
        nearest_x = wayPoints[_i].x;
        nearest_aux_x = _i;
	}
    if(abs(_i-nearest_y) < enemies[enemy].position.y){
        nearest_y = wayPoints[_i].y;
        nearest_aux_y = _i;
    }
}

if(nearest_aux_x == nearest_aux_y){
    nearest = nearest_aux_x;
}

}
void moveEnemyRandom(unsigned char enemy)
{

  if(backgroundTiles_[enemies[enemy].position.x +1][enemies[enemy].position.y] == MAP_BORDER)
    enemies[enemy].direction = ENEMY_LEFT;
  else if(backgroundTiles_[enemies[enemy].position.x -1][enemies[enemy].position.y] == MAP_BORDER)
    enemies[enemy].direction = ENEMY_RIGHT;
  else if(backgroundTiles_[enemies[enemy].position.x][enemies[enemy].position.y+1] == MAP_BORDER)
    enemies[enemy].direction = ENEMY_UP;
  else if(backgroundTiles_[enemies[enemy].position.x][enemies[enemy].position.y-1] == MAP_BORDER)
   enemies[enemy].direction = ENEMY_DOWN;

  switch(enemies[enemy].direction)
  {
    case ENEMY_UP: enemies[enemy].position.y--;
    break;
    case ENEMY_DOWN: enemies[enemy].position.y++;
    break;
    case ENEMY_RIGHT: enemies[enemy].position.x++;
    break;
    case ENEMY_LEFT: enemies[enemy].position.x--;
    break;
  }

}
void moveEnemyView(unsigned char enemy)
{

unsigned char q;

q = nearWayPointorCharacter(enemy);

    if(q > MAX_WAYPOINTS + 1){
// The character is closet
// BASIC IA
//if(ArcadeMap[(enemies[a].position.x+1)*ARCADEMAP_WIDTH + enemies[a].position.y]==0){
          if(positionOfCharacter.x > enemies[enemy].position.x) {

             enemies[enemy].position.x++;

          }
          else if(positionOfCharacter.x < enemies[enemy].position.x) {

                  enemies[enemy].position.x--;

          }

          else if(positionOfCharacter.y > enemies[enemy].position.y) {

                  enemies[enemy].position.y++;

          }

          else if(positionOfCharacter.y < enemies[enemy].position.y) {

                  enemies[enemy].position.y--;

          }

    }
	else{

         if(wayPoints[q].x > enemies[enemy].position.x) {

                  enemies[enemy].position.x++;

          }

          else if(wayPoints[q].x < enemies[enemy].position.x) {

                  enemies[enemy].position.x--;

          }

          else if(wayPoints[q].y > enemies[enemy].position.y) {

                  enemies[enemy].position.y++;

          }

          else if(wayPoints[q].y < enemies[enemy].position.y) {

                  enemies[enemy].position.y--;

          }
    }
}




void moveEnemyFootprint(unsigned char enemy)
{
  unsigned char a;
  enemies[enemy].state = QUIT_ALERT;

  for(a=0;a<MAX_FOOTPRINTS;a++)
  {
  	if((enemies[enemy].position.x + 1 == footPrints[a].x && enemies[enemy].position.y == footPrints[a].y)
  		 || backgroundTiles_[enemies[enemy].position.x + 1][enemies[enemy].position.y] == MAP_CHARACTER){
  			enemies[enemy].position.x++;
      enemies[enemy].state = ALERT;
        break;
  	}else if((enemies[enemy].position.x - 1 == footPrints[a].x && enemies[enemy].position.y == footPrints[a].y)
  		 	|| backgroundTiles_[enemies[enemy].position.x - 1][enemies[enemy].position.y] == MAP_CHARACTER){
  			   enemies[enemy].position.x--;
           enemies[enemy].state = ALERT;
           break;
  	}else if((enemies[enemy].position.x == footPrints[a].x && enemies[enemy].position.y + 1 == footPrints[a].y)
  		 	|| backgroundTiles_[enemies[enemy].position.x][enemies[enemy].position.y + 1] == MAP_CHARACTER){
  			   enemies[enemy].position.y++;
           enemies[enemy].state = ALERT;
           break;
  	}else if((enemies[enemy].position.x == footPrints[a].x && enemies[enemy].position.y - 1 == footPrints[a].y)
  		 	|| backgroundTiles_[enemies[enemy].position.x][enemies[enemy].position.y - 1] == MAP_CHARACTER){
  			   enemies[enemy].position.y--;
           enemies[enemy].state = ALERT;
           break;
  	}
  }

  
  
}



/**
  @brief Processing the enemy movement.
*/
void enemyMovement()
{

  unsigned char a,b,_i,_j;

  for(a=0;a<ENEMIES;++a){
	  if(enemies[a].life != 0) {
      enemies[a].position.ox = enemies[a].position.x;
      enemies[a].position.oy = enemies[a].position.y;
    
/* if(ArcadeMap[enemies[a].position.x*ARCADEMAP_WIDTH + enemies[a].position.y]==0){ */
// BASIC AI: persecute main character
      switch(enemies[a].state){

        case QUIET: moveEnemyRandom(a);
        break;
        case ALERT: moveEnemyFootprint(a);
        break;
	  case AWARE: //moveEnemyView(a); //por hacer
        break;

      }
//}
// if(nearWayPointorCharacter(a) > MAX_WAYPOINTS){ 


//  enemies[a].state = AWARE; 
// } 
      
      if(backgroundTiles_[enemies[a].position.x][enemies[a].position.y]==MAP_FOOTPRINT && enemies[a].state == QUIET)
          enemies[a].state = ALERT;
      if(enemies[a].state == QUIT_ALERT)
          enemies[a].state = QUIET;
      else if(enemies[a].state == QUIET){
              for(b=0;b<MAX_FOOTPRINTS;++b)
              {
                if(enemies[a].position.x == footPrints[b].x && enemies[a].position.y == footPrints[b].y)
                {
                  enemies[a].state = ALERT;
                  break;
                }
              }  
      }

      if(enemies[a].position.ox!=enemies[a].position.x || enemies[a].position.oy!=enemies[a].position.y) {
        backgroundTiles_[enemies[a].position.ox][enemies[a].position.oy]= MAP_NONE;
        backgroundTiles_[enemies[a].position.x][enemies[a].position.y]= MAP_ENEMY;        
      }

      // Detect if the enemy is on character
    if(enemies[a].position.x == positionOfCharacter.x && enemies[a].position.y == positionOfCharacter.y) {
      // What to do?
      // GAME OVER
      for (_i = 0; _i < ARCADEMAP_WIDTH; _i++) 
        for (_j = 0; _j < ARCADEMAP_HEIGHT; _j++){
          backgroundTiles_[_i][_j] = MAP_BORDER;
          //go = 1;
        }
      }
    }
	  else{
		  switch(a){
		  case 0:
			  		    // Enemy on left up corner
  enemies[0].position.ox = enemies[0].position.x = 3;
  enemies[0].position.oy = enemies[0].position.y = 2;
  enemies[0].state = QUIET;
  enemies[0].direction = ENEMY_RIGHT;
  enemies[0].life = 1 + level;
  break;

		  // The enemy is dead
		  case 1:
  // Enemy on right down corner
  enemies[1].position.ox = enemies[1].position.x = (ARCADEMAP_WIDTH-3);
  enemies[1].position.oy = enemies[1].position.y = (ARCADEMAP_HEIGHT-3);
  enemies[1].state = QUIET;
  enemies[1].direction = ENEMY_LEFT;
  enemies[1].life = 1 + level;
  break;
  // Enemy on right up corner
		  case 3: 
  enemies[3].position.ox = enemies[3].position.x = (ARCADEMAP_WIDTH-3);
  enemies[3].position.oy = enemies[3].position.y = 3;
  enemies[3].state = QUIET;
  enemies[3].direction = ENEMY_DOWN;
  enemies[3].life = 1 + level;
  break;
// Enemy on left down corner
		  case 2:
  enemies[2].position.ox = enemies[2].position.x = 3;
  enemies[2].position.oy = enemies[2].position.y = (ARCADEMAP_HEIGHT-3);
  enemies[2].state = QUIET;
  enemies[2].direction = ENEMY_UP;
  enemies[2].life = 1 + level;
  break;
    // Enemy on left up corner
		  case 4:
  enemies[4].position.ox = enemies[4].position.x = 10;
  enemies[4].position.oy = enemies[4].position.y = 15;
  enemies[4].state = QUIET;
  enemies[4].direction = ENEMY_RIGHT;
  enemies[4].life = 1 + level;
  break;
  // Enemy on right down corner
		  case 5:
  enemies[5].position.ox = enemies[5].position.x = (ARCADEMAP_WIDTH-10);
  enemies[5].position.oy = enemies[5].position.y = (ARCADEMAP_HEIGHT-15);
  enemies[5].state = QUIET;
  enemies[5].direction = ENEMY_LEFT;
  enemies[5].life = 1 + level;
  break;
  // Enemy on right up corner
		  case 6:
  enemies[6].position.ox = enemies[6].position.x = (ARCADEMAP_WIDTH-10);
  enemies[6].position.oy = enemies[6].position.y = 15;
  enemies[6].state = QUIET;
  enemies[6].direction = ENEMY_DOWN;
  enemies[6].life = 1 + level;
  break;
// Enemy on left down corner
		  case 7:
  enemies[7].position.ox = enemies[7].position.x = 10;
  enemies[7].position.oy = enemies[7].position.y = (ARCADEMAP_HEIGHT-15);
  enemies[7].state = QUIET;
  enemies[7].direction = ENEMY_UP;
  enemies[7].life = 1 + level;
  break;
	  }
  }
}
}

/**
  @brief Initialize the position.
*/
void initModel()
{
  positionOnMap.ox = positionOnMap.x = ARCADEMAP_WIDTH/2 - NUM_TILES_WIDTH/2;
  positionOnMap.oy = positionOnMap.y = ARCADEMAP_HEIGHT/2 - NUM_TILES_HEIGHT/2;

  positionOfCharacter.ox = positionOfCharacter.x = positionOnMap.x + (NUM_TILES_WIDTH/2);
  positionOfCharacter.oy = positionOfCharacter.y = positionOnMap.y + (NUM_TILES_HEIGHT/2);


  // Enemy on left up corner
  enemies[0].position.ox = enemies[0].position.x = 3;
  enemies[0].position.oy = enemies[0].position.y = 2;
  enemies[0].state = QUIET;
  enemies[0].direction = ENEMY_RIGHT;
  enemies[0].life = 1;
  // Enemy on right down corner
  enemies[1].position.ox = enemies[1].position.x = (ARCADEMAP_WIDTH-3);
  enemies[1].position.oy = enemies[1].position.y = (ARCADEMAP_HEIGHT-3);
  enemies[1].state = QUIET;
  enemies[1].direction = ENEMY_LEFT;
  enemies[1].life = 1;

  // Enemy on right up corner
  enemies[3].position.ox = enemies[3].position.x = (ARCADEMAP_WIDTH-3);
  enemies[3].position.oy = enemies[3].position.y = 3;
  enemies[3].state = QUIET;
  enemies[3].direction = ENEMY_DOWN;
  enemies[3].life = 1;
// Enemy on left down corner
  enemies[2].position.ox = enemies[2].position.x = 3;
  enemies[2].position.oy = enemies[2].position.y = (ARCADEMAP_HEIGHT-3);
  enemies[2].state = QUIET;
  enemies[2].direction = ENEMY_UP;
  enemies[2].life = 1;

    // Enemy on left up corner
  enemies[4].position.ox = enemies[4].position.x = 10;
  enemies[4].position.oy = enemies[4].position.y = 15;
  enemies[4].state = QUIET;
  enemies[4].direction = ENEMY_RIGHT;
  enemies[4].life = 1;
  // Enemy on right down corner
  enemies[5].position.ox = enemies[5].position.x = (ARCADEMAP_WIDTH-10);
  enemies[5].position.oy = enemies[5].position.y = (ARCADEMAP_HEIGHT-15);
  enemies[5].state = QUIET;
  enemies[5].direction = ENEMY_LEFT;
  enemies[5].life = 1;

  // Enemy on right up corner
  enemies[6].position.ox = enemies[6].position.x = (ARCADEMAP_WIDTH-10);
  enemies[6].position.oy = enemies[6].position.y = 15;
  enemies[6].state = QUIET;
  enemies[6].direction = ENEMY_DOWN;
  enemies[6].life = 1;
// Enemy on left down corner
  enemies[7].position.ox = enemies[7].position.x = 10;
  enemies[7].position.oy = enemies[7].position.y = (ARCADEMAP_HEIGHT-15);
  enemies[7].state = QUIET;
  enemies[7].direction = ENEMY_UP;
  enemies[7].life = 1; 
}

/**
  @brief Initialize the map. ONLY CALL ONE TIME!!!!!!!!!!!!!!!!!!!
*/  
void initTileMap()
{
  unsigned char x,y,a;
  huellas = 0;
  initModel();

  for(x=0; x<ARCADEMAP_WIDTH; x++)
  {
    for(y=0; y<ARCADEMAP_HEIGHT; y++)
    {
      switch(ArcadeMap[x*ARCADEMAP_WIDTH + y])
      {
        case 0: backgroundTiles_[x][y]= MAP_NONE; break;
        case 1: backgroundTiles_[x][y]= MAP_BORDER; break;
      }
    }
  }
  backgroundTiles_[positionOfCharacter.x][positionOfCharacter.y]= MAP_CHARACTER;

  // Set the enemies on map
  for(a=0;a<ENEMIES;++a)
      backgroundTiles_[enemies[a].position.x][enemies[a].position.y]= MAP_ENEMY;

}


void moveCharacterShoots(const unsigned char keys)
{
  //Update Shoots
    //SHOOTS EFICIENTES

  //Comprobamos que se ha pulsado alguna tecla de disparo y que el cargador no esta vacio.(No hayan el MAX de disparos en pantalla)
  //0x07 Disparos que !izquierda
  //0x0A Disparos que !Derecha
  //0x0D Disparos que !Arriba
  //0x0E Disparos que !Abajo
  if((keys & 0x0F) && !(shootsCartridge & MaxShoots) && (positionOfCharacter.x>0x01 || keys & 0x07)  && (positionOfCharacter.y>0x01 || keys & 0x0D) && (positionOfCharacter.x < ARCADEMAP_WIDTH-0x02 || keys & 0x0B) && (positionOfCharacter.y < ARCADEMAP_HEIGHT-0x02 || keys & 0x0E)) {  //Preguntar que es mas eficiente si !& o ^
	  unsigned char aux = 0x01;
      unsigned char posicionVector = 0x00;
	  //Detecto la bala del cartucho que esta disponible.
	  for(aux = 0x01; aux<MaxShoots; aux<<=1) {
		  //En cuanto disponga de una posicion libre en el vector entro.
		  if(!(aux & shootsCartridge)) {
			  //EMPEZAR A DARLE
			  break;
		  }
		  ++posicionVector;
	  }
	  
	  //Pongo las posiciones del disparo en las del personaje.
	  characterShoots[posicionVector].position.ox =characterShoots[posicionVector].position.x = positionOfCharacter.x;
	  characterShoots[posicionVector].position.oy = characterShoots[posicionVector].position.y = positionOfCharacter.y;
	  //Obtenemos la direccion del disparo.
	  if(keys & 0x08)
		  characterShoots[posicionVector].dir = 0x08;
      else if(keys & 0x04) 
		  characterShoots[posicionVector].dir = 0x04;
	  else if(keys & 0x02)
		  characterShoots[posicionVector].dir = 0x02;
	  else if(keys & 0x01)
		  characterShoots[posicionVector].dir = 0x01;
	  
	  shootsCartridge^=aux; //Ponemos el disparo en el char. 
          //EJ: shoots= 0000 0101 ^ (aux = 0000 0010) = 0000 0111.
  }
}


void moveCharacterAndMap(const unsigned char keys)
{

	unsigned char a,_i,_j,go;
  unsigned char posX, posY;
	go=0;
  posX= positionOfCharacter.x;
  posY= positionOfCharacter.y;


  positionOnMap.ox = positionOnMap.x;
  positionOnMap.oy = positionOnMap.y;

  positionOfCharacter.ox = positionOfCharacter.x;
  positionOfCharacter.oy = positionOfCharacter.y;

  if(keys & 0x80)
  {
   if(ArcadeMap[(posX+1)*ARCADEMAP_WIDTH + posY]==0)//(backgroundTiles_[posX+1][posY]==MAP_NONE || backgroundTiles_[posX+1][posY]==MAP_SHOOT || backgroundTiles_[posX+1][posY]==MAP_ENEMY)
   {
      if((positionOfCharacter.x>=1 && positionOfCharacter.x<NUM_TILES_WIDTH/2) ||
        (positionOfCharacter.x>=ARCADEMAP_WIDTH-NUM_TILES_WIDTH/2 && positionOfCharacter.x<ARCADEMAP_WIDTH-2))
      {
        positionOfCharacter.x++;
      }
      else 
      {
        if((positionOnMap.x + NUM_TILES_WIDTH) < ARCADEMAP_WIDTH) 
        {
          positionOnMap.x++;
          positionOfCharacter.x++;
        }
      }
    }
  }
  else if(keys & 0x40)
  {
    if(ArcadeMap[(posX-1)*ARCADEMAP_WIDTH + posY]==0)//(backgroundTiles_[posX+1][posY]==MAP_NONE || backgroundTiles_[posX+1][posY]==MAP_SHOOT || backgroundTiles_[posX+1][posY]==MAP_ENEMY)
    {
      if((positionOfCharacter.x>1 && positionOfCharacter.x<=NUM_TILES_WIDTH/2) ||
        (positionOfCharacter.x>ARCADEMAP_WIDTH-NUM_TILES_WIDTH/2 && positionOfCharacter.x<ARCADEMAP_WIDTH))
      {
        positionOfCharacter.x--;
      }
      else 
      {
        if(positionOnMap.x > 0)
        {
          positionOnMap.x--;
          positionOfCharacter.x--;
        }
      }
    } 
  }
  else if(keys & 0x20)
  {
    if(ArcadeMap[posX*ARCADEMAP_WIDTH + (posY-1)]==0)//positionOfCharacter.y-1==MAP_NONE || positionOfCharacter.y-1==MAP_SHOOT || positionOfCharacter.y-1==MAP_ENEMY)
    {
      if((positionOfCharacter.y>1 && positionOfCharacter.y<=NUM_TILES_HEIGHT/2) ||
        (positionOfCharacter.y>ARCADEMAP_HEIGHT-NUM_TILES_HEIGHT/2 && positionOfCharacter.y<ARCADEMAP_HEIGHT))
        {
          positionOfCharacter.y--;
        }
      else
      {
        if(positionOnMap.y>0) 
        {
          positionOnMap.y--;
          positionOfCharacter.y--;
        }
      }
    }
  }
  else if(keys & 0x10)
  {
    if(ArcadeMap[posX*ARCADEMAP_WIDTH + (posY+1)]==0)//positionOfCharacter.y+1==MAP_NONE || positionOfCharacter.y+1==MAP_SHOOT || positionOfCharacter.y+1==MAP_ENEMY)
    {
      if((positionOfCharacter.y>=1 && positionOfCharacter.y<NUM_TILES_HEIGHT/2) ||
        (positionOfCharacter.y>=ARCADEMAP_HEIGHT-NUM_TILES_HEIGHT/2 && positionOfCharacter.y<ARCADEMAP_HEIGHT-2))
        {
          positionOfCharacter.y++;
        }
      else
      {
        if((positionOnMap.y + NUM_TILES_HEIGHT) < ARCADEMAP_HEIGHT) 
        {
          positionOnMap.y++;
          positionOfCharacter.y++;
        }
      }
    }
  }
    // BASIC AI: persecute main character
  
  if(positionOfCharacter.ox!=positionOfCharacter.x || positionOfCharacter.oy!=positionOfCharacter.y) {
      backgroundTiles_[positionOfCharacter.ox][positionOfCharacter.oy]= MAP_NONE;
      backgroundTiles_[positionOfCharacter.x][positionOfCharacter.y]= MAP_CHARACTER;
       if(huellas>9){
        footPrints[huellas%10].x = positionOfCharacter.ox;
        footPrints[huellas%10].y = positionOfCharacter.oy;
      }else {
        footPrints[huellas].x = positionOfCharacter.ox;
        footPrints[huellas].y = positionOfCharacter.oy;
      }
      huellas++;
    }

  //Later, first update shoots and enemys
  if(positionOfCharacter.ox!=positionOfCharacter.x || positionOfCharacter.oy!=positionOfCharacter.y) {
      backgroundTiles_[positionOfCharacter.ox][positionOfCharacter.oy]= MAP_NONE;
      backgroundTiles_[positionOfCharacter.x][positionOfCharacter.y]= MAP_CHARACTER;
  }
}


void moveShots() 
{
	unsigned char aux, enemy;
	unsigned char posicionVector = 0x00;
		
	for(aux = 0x01; aux <= MaxShoots; aux<<=1) {
		if(shootsCartridge & aux) { //Comprobamos la posicion de la bala en el cartucho
			//Borramos el rastro del disparo.
			//Creamos variables locales de las posiciones del disparo para un mejor acceso.
			unsigned int auxX = characterShoots[posicionVector].position.x; //TODO Task #4822
			unsigned int auxY = characterShoots[posicionVector].position.y;
			
			if(backgroundTiles_[auxX][auxY]!= MAP_CHARACTER)
				backgroundTiles_[auxX][auxY]= MAP_NONE;
			
			characterShoots[posicionVector].position.ox = auxX;
			characterShoots[posicionVector].position.oy = auxY;
			//Actualizamos la posicion del disparo segun su direccion.
			if(characterShoots[posicionVector].dir & 0x08 && auxX > 0x00) { // Disparo Izquierda
				auxX -= 0x01;
			}
			else if(characterShoots[posicionVector].dir & 0x04 && auxX < ARCADEMAP_WIDTH-0x01) { //Disparo Derecha
				auxX += 0x01;
			}
			else if(characterShoots[posicionVector].dir & 0x02 && auxY > 0x00) { //Disparo Arriba
				auxY -= 0x01;
			}else if(characterShoots[posicionVector].dir & 0x01 && auxY <ARCADEMAP_HEIGHT-0x01) { //Disparo Abajo
				auxY += 0x01;
			}
			//Comprobamos los disparos con el mapa.
			if(backgroundTiles_[auxX][auxY] == MAP_BORDER) {
				shootsCartridge &= (0xFF ^ aux); //Quitamos la bala del cartucho.
				//Realizar una explosion y quitarla en la siguiente iteracion, no se como hacerlo exactamente.
			}
			if(backgroundTiles_[auxX][auxY] == MAP_ENEMY) {
				//Realizar tareas con los enemigos.
				backgroundTiles_[auxX][auxY] = MAP_ILLENEMY;
				for(enemy = 0; enemy<ENEMIES;++enemy){
					if(enemies[enemy].position.x == auxX && enemies[enemy].position.y == auxY) {
						enemies[enemy].life -= 1;
						level = level + 1;
						break;
					}
				}
				shootsCartridge &= (0xFF ^ aux); //Quitamos la bala del cartucho.
			}
			if(backgroundTiles_[auxX][auxY] == MAP_NONE) {
				if(characterShoots[posicionVector].dir & 0x08) 
				{
					backgroundTiles_[auxX][auxY] = MAP_SHOOT;
				}
				else if(characterShoots[posicionVector].dir & 0x04) {
					backgroundTiles_[auxX][auxY] = MAP_SHOOTH2;
				}
				else if(characterShoots[posicionVector].dir & 0x02) {
					backgroundTiles_[auxX][auxY] = MAP_SHOOTV1;
				}
				else {
					backgroundTiles_[auxX][auxY] = MAP_SHOOTV2;
				}
			}
			characterShoots[posicionVector].position.x = auxX;
			characterShoots[posicionVector].position.y = auxY;
		}
		
		//Simplemente para comprobar que se vacia el cartucho. Procedimiento, tendremos que observar como se pinta y se despinta el personaje en la posicion [5,0] a medida que creamos disparos.
		
		/* if(shootsCartridge & 0xFF) { //Si hay alguna bala en el cartucho se pinta un personaje. */
		/* 	backgroundTiles_[0x05][0x00] = MAP_CHARACTER; */
		/* } else { //Sino se borra. */
		/* 	backgroundTiles_[0x05][0x00] = MAP_BORDER; */
		/* }		 */
		++posicionVector;                			
	}	
}


/**
  @brief Setting the model with the pressed keys.

  @param[in] keys The pressed keys.
*/
void setModel(unsigned char const keys)
{
  unsigned char _i, _j;
  
  for(_i=0; _i<ARCADEMAP_WIDTH; ++_i)
    for(_j=0; _j<ARCADEMAP_HEIGHT; ++_j)
      backgroundTilesSecondary_[_i][_j]= backgroundTiles_[_i][_j];

  enemyMovement();
  moveCharacterAndMap(keys);
  moveCharacterShoots(keys);
  if(shootsCartridge & 0xFF)
     moveShots();
}

#endif
