/* This file is part of Ebola: El octavo pasajero. */

/*     Ebola: El octavo pasajero is free software: you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License as published by */
/*     the Free Software Foundation, either version 3 of the License, or */
/*     (at your option) any later version. */

/*     Ebola: El octavo pasajero is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with Ebola: El octavo pasajero.  If not, see <http://www.gnu.org/licenses/>. */

/*
  @file my_sprites.h
  @brief The sprites file.
  @author Jesus Manresa Parres
  @version 1
*/

#ifndef __MY_SPRITES_H__
#define __MY_SPRITES_H__

/**
  @short The number of used colors.
*/
#define NUM_COLORS 16

/**
  @short The palette. 
*/
const unsigned char palette_[NUM_COLORS] = {0x01, 0x18, 0x14, 0x06, 0x1A, 0x00, 0x02, 0x08,
                                            0x0A, 0x0C, 0x0E, 0x10, 0x12, 0x16, 0x0D, 0x09};

/**
    @brief The sprite border.
*/
extern const unsigned char SpriteBorder[];

/**
    @brief The sprite grass.
*/
extern const unsigned char SpriteGrass[];

/**
    @brief The sprite of character.
*/
extern const unsigned char SpriteCharacter[];

extern const unsigned char SpriteShootH1[];
extern const unsigned char SpriteShootH2[];
extern const unsigned char SpriteShootV1[];
extern const unsigned char SpriteShootV2[];

extern const unsigned char SpriteEnemy[];
extern const unsigned char SpriteIllEnemy[];
extern const unsigned char SpriteExplosion[];

extern const unsigned char SpriteHeartEmpty[];
extern const unsigned char SpriteHeartFull[];
extern const unsigned char SpriteCamilla[];


void data(void)
{
  __asm


	  _SpriteBorder:
.db #0xF0,#0xF0,#0xF0,#0xF0
.db #0xF0,#0xE4,#0xD8,#0xF0
.db #0xF0,#0xE4,#0xD8,#0xF0
.db #0xE4,#0xCC,#0xCC,#0xD8
.db #0xE4,#0xCC,#0xCC,#0xD8
.db #0xF0,#0xE4,#0xD8,#0xF0
.db #0xF0,#0xE4,#0xD8,#0xF0
.db #0xF0,#0xF0,#0xF0,#0xF0

	  _SpriteGrass:
.db #0x30,#0x30,#0xB0,#0x30
.db #0x30,#0x30,#0xB0,#0x30
.db #0x30,#0x30,#0xB0,#0x30
.db #0xF0,#0xF0,#0xF0,#0xF0
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30



	  _SpriteCharacter:
.db #0xC3,#0xC3,#0xC3,#0xC3
.db #0xD2,#0xF0,#0xF0,#0xE1
.db #0xD2,#0x70,#0xB0,#0xE1
.db #0xD2,#0xE4,#0xD8,#0xE1
.db #0xA5,#0xF0,#0xF0,#0x5A
.db #0x0F,#0x0F,#0x0F,#0x0F
.db #0x3C,#0x3C,#0x3C,#0x3C
.db #0xF0,#0xB4,#0x78,#0xF0

	  _SpriteShootH1:
.db #0x30,#0x30,#0xB0,#0x30
.db #0x30,#0x30,#0xB0,#0x30
.db #0x98,#0xCC,#0x98,#0xCC
.db #0xD8,#0xD8,#0xD8,#0xD8
.db #0xCC,#0xD8,#0xCC,#0x98
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30


	  _SpriteShootH2:
.db #0x30,#0x30,#0xB0,#0x30
.db #0x30,#0x30,#0xB0,#0x30
.db #0xCC,#0x98,#0xCC,#0x98
.db #0xD8,#0xD8,#0xD8,#0xD8
.db #0x98,#0xCC,#0x98,#0xCC
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30
.db #0x30,#0x70,#0x30,#0x30



	  _SpriteShootV1:
.db #0x30,#0x98,#0xB0,#0x30
.db #0x30,#0xCC,#0xCC,#0x30
.db #0x30,#0x30,#0xE4,#0x30
.db #0xF0,#0xCC,#0xCC,#0xF0
.db #0x30,#0xD8,#0x30,#0x30
.db #0x30,#0xCC,#0xCC,#0x30
.db #0x30,#0x70,#0x64,#0x30
.db #0x30,#0xCC,#0xCC,#0x30


	  _SpriteShootV2:
.db #0x30,#0x30,#0xE4,#0x30
.db #0x30,#0xCC,#0xCC,#0x30
.db #0x30,#0x98,#0xB0,#0x30
.db #0xF0,#0xCC,#0xCC,#0xF0
.db #0x30,#0x70,#0x64,#0x30
.db #0x30,#0xCC,#0xCC,#0x30
.db #0x30,#0xD8,#0x30,#0x30
.db #0x30,#0xCC,#0xCC,#0x30


	  _SpriteEnemy:
.db #0x03,#0x03,#0x03,#0x03
.db #0x47,#0xCF,#0xCF,#0x8B
.db #0x47,#0x6D,#0x9E,#0x8B
.db #0x0C,#0x0C,#0x0C,#0x0C
.db #0x9A,#0x0C,#0x0C,#0x65
.db #0x9A,#0x24,#0x18,#0x65
.db #0x30,#0x30,#0x30,#0x30
.db #0xCF,#0x9A,#0x65,#0xCF


	  _SpriteIllEnemy:
.db #0x03,#0x03,#0x03,#0x03
.db #0x57,#0xFF,#0xFF,#0xAB
.db #0x57,#0x7D,#0xBE,#0xAB
.db #0x0C,#0x0C,#0x0C,#0x0C
.db #0xBA,#0x0C,#0x0C,#0x75
.db #0xBA,#0x24,#0x18,#0x75
.db #0x30,#0x30,#0x30,#0x30
.db #0xFF,#0xBA,#0x75,#0xFF


	  _SpriteExplosion:
.db #0xBA,#0x30,#0xB0,#0x75
.db #0x75,#0x30,#0xB0,#0xBA
.db #0x30,#0xBA,#0xF5,#0x30
.db #0xF0,#0xF5,#0xFA,#0xF0
.db #0x30,#0x75,#0xBA,#0x30
.db #0x30,#0xFA,#0x75,#0x30
.db #0x75,#0x70,#0x30,#0xBA
.db #0xBA,#0x70,#0x30,#0x75

	  _SpriteHeartEmpty:
.db #0x3F,#0x3F,#0x3F,#0x3F
.db #0x7A,#0xB5,#0x7A,#0xB5
.db #0xB5,#0x7A,#0xB5,#0x7A
.db #0xB5,#0x3F,#0x3F,#0x7A
.db #0x7A,#0x3F,#0x3F,#0xB5
.db #0x3F,#0xB5,#0x7A,#0x3F
.db #0x3F,#0x7A,#0xB5,#0x3F
.db #0x3F,#0x3F,#0x3F,#0x3F


	  _SpriteHeartFull:
.db #0x3F,#0x3F,#0x3F,#0x3F
.db #0x7A,#0xB5,#0x7A,#0xB5
.db #0xE4,#0xD8,#0xE4,#0xD8
.db #0xE4,#0xCC,#0xCC,#0xD8
.db #0x7A,#0xCC,#0xCC,#0xB5
.db #0x3F,#0xE4,#0xD8,#0x3F
.db #0x3F,#0x7A,#0xB5,#0x3F
.db #0x3F,#0x3F,#0x3F,#0x3F

	  _SpriteCamilla:
.db #0x00,#0x00,#0x30,#0x20
.db #0x00,#0x44,#0xCC,#0x88
.db #0x00,#0x30,#0x30,#0x20
.db #0x10,#0x30,#0x30,#0x2A
.db #0x30,#0x30,#0x20,#0x2A
.db #0x3A,#0x35,#0x00,#0x2A
.db #0x2A,#0x15,#0x00,#0x00
.db #0x2A,#0x15,#0x00,#0x00
  __endasm;
}

#endif
